# Class VulkanPipelineViewportStateCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineViewportStateCreateInfo.Builder

Enclosing class:
  `VulkanPipelineViewportStateCreateInfo`

public static final class VulkanPipelineViewportStateCreateInfo.Builder extends Object
Builds instances of type `VulkanPipelineViewportStateCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanPipelineViewportStateCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addAllScissors(Iterable<? extends VulkanRectangle2D> elements)`
  Adds elements to `scissors` list.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addAllViewports(Iterable<? extends VulkanViewport> elements)`
  Adds elements to `viewports` list.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addFlags(VulkanPipelineViewportStateCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addFlags(VulkanPipelineViewportStateCreateFlag... elements)`
  Adds elements to `flags` set.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addScissors(VulkanRectangle2D element)`
  Adds one element to `scissors` list.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addScissors(VulkanRectangle2D... elements)`
  Adds elements to `scissors` list.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addViewports(VulkanViewport element)`
  Adds one element to `viewports` list.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `addViewports(VulkanViewport... elements)`
  Adds elements to `viewports` list.
  `VulkanPipelineViewportStateCreateInfo`
  `build()`
  Builds a new `VulkanPipelineViewportStateCreateInfo`.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `from(VulkanPipelineViewportStateCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanPipelineViewportStateCreateInfoType` instance.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `setFlags(Iterable<VulkanPipelineViewportStateCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `setScissors(Iterable<? extends VulkanRectangle2D> elements)`
  Sets or replaces all elements for `scissors` list.
  `final VulkanPipelineViewportStateCreateInfo.Builder`
  `setViewports(Iterable<? extends VulkanViewport> elements)`
  Sets or replaces all elements for `viewports` list.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanPipelineViewportStateCreateInfo.Builder from(VulkanPipelineViewportStateCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanPipelineViewportStateCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanPipelineViewportStateCreateInfo.Builder addFlags(VulkanPipelineViewportStateCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanPipelineViewportStateCreateInfo.Builder addFlags(VulkanPipelineViewportStateCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanPipelineViewportStateCreateInfo.Builder setFlags(Iterable<VulkanPipelineViewportStateCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanPipelineViewportStateCreateInfo.Builder addAllFlags(Iterable<VulkanPipelineViewportStateCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addViewports

    public final VulkanPipelineViewportStateCreateInfo.Builder addViewports(VulkanViewport element)
    Adds one element to `viewports` list.
    Parameters:
      `element` - A viewports element
    Returns:
      `this` builder for use in a chained invocation

  - ### addViewports

    public final VulkanPipelineViewportStateCreateInfo.Builder addViewports(VulkanViewport... elements)
    Adds elements to `viewports` list.
    Parameters:
      `elements` - An array of viewports elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setViewports

    public final VulkanPipelineViewportStateCreateInfo.Builder setViewports(Iterable<? extends VulkanViewport> elements)
    Sets or replaces all elements for `viewports` list.
    Parameters:
      `elements` - An iterable of viewports elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllViewports

    public final VulkanPipelineViewportStateCreateInfo.Builder addAllViewports(Iterable<? extends VulkanViewport> elements)
    Adds elements to `viewports` list.
    Parameters:
      `elements` - An iterable of viewports elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addScissors

    public final VulkanPipelineViewportStateCreateInfo.Builder addScissors(VulkanRectangle2D element)
    Adds one element to `scissors` list.
    Parameters:
      `element` - A scissors element
    Returns:
      `this` builder for use in a chained invocation

  - ### addScissors

    public final VulkanPipelineViewportStateCreateInfo.Builder addScissors(VulkanRectangle2D... elements)
    Adds elements to `scissors` list.
    Parameters:
      `elements` - An array of scissors elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setScissors

    public final VulkanPipelineViewportStateCreateInfo.Builder setScissors(Iterable<? extends VulkanRectangle2D> elements)
    Sets or replaces all elements for `scissors` list.
    Parameters:
      `elements` - An iterable of scissors elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllScissors

    public final VulkanPipelineViewportStateCreateInfo.Builder addAllScissors(Iterable<? extends VulkanRectangle2D> elements)
    Adds elements to `scissors` list.
    Parameters:
      `elements` - An iterable of scissors elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanPipelineViewportStateCreateInfo build()
    Builds a new `VulkanPipelineViewportStateCreateInfo`.
    Returns:
      An immutable instance of VulkanPipelineViewportStateCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing